#ifndef CONTACTLIST_H_INCLUDED
#define CONTACTLIST_H_INCLUDED
#include "gtk-gui.h"

#define SEND_OVERRIDE_URGENT 1
#define SEND_OVERRIDE_LIST 2

void 
refresh_contactlist                    (unsigned int    group);

void 
refresh_contactlist_single_user        (unsigned long   
                                                    uin);

void 
real_refresh_contactlist               (unsigned int    
                                                    group,
                                        GtkWidget   *contactlist,
                                        gboolean    ismainlist,
                                        GList       *selection);

void
refresh_eventwindows_contactlists();

void 
refresh_grouplist();

int
add_group_to_grouplist                 (GtkWidget   *new_menu, 
                                        GtkSignalFunc
                                                    func,
                                        const gchar *title,
                                        int         id);

void
on_add_to_group_clicked                (GtkMenuItem *button,
                                        gpointer    user_data);

GList *
get_contactlist_selected_uin           (GtkWidget   *contactlist);

gboolean
on_alias_clist_drag_drop               (GtkWidget   *widget,
                                        GdkDragContext
                                                    *context,
                                        gint        x,
                                        gint        y,
                                        guint       time);

void
on_alias_clist_drag_data_received      (GtkWidget   *widget,
                                        GdkDragContext
                                                    *context,
                                        gint        x,
                                        gint        y,
                                        GtkSelectionData   
                                                    *data,
                                        guint       info,
                                        guint       time);

gboolean
on_alias_clist_drag_motion             (GtkWidget   *widget,
                                        GdkDragContext
                                                    *context,
                                        gint        x,
                                        gint        y,
                                        guint       time);

void
on_contacts_list_drag_data_get         (GtkWidget   *contactlist,
                                        GdkDragContext
                                                    *drag_context,
                                        GtkSelectionData 
                                                    *data,
                                        guint       info,
                                        guint       time,
                                        gpointer    user_data);

gboolean
icon_blink_function                    (gpointer    data);

void
refresh_floating_windows();

GtkWidget   *
create_floating_window_contents        (GtkWindow   *win);

GtkWidget   *
create_user_floating_window            (unsigned long
                                                    uin);

void
rebuild_all_floating_windows();

gboolean
on_floating_user_button_press_event    (GtkWidget   *widget,
                                        GdkEventButton
                                                    *event,
                                        gpointer    user_data);

gboolean
on_floating_user_delete_event          (GtkWidget   *widget,
                                        GdkEvent    *event,
                                        gpointer    user_data);

void 
real_refresh_contactlist_single_user   (unsigned int
                                                    group,
                                        GroupType   gtype,
                                        GtkWidget   *contactlist,
                                        gboolean    ismainlist,
                                        userdata_t  *udata,
                                        GList       *selection,
                                        ICQUser     *pUser,
                                        gint        row);

#endif  /* CONTACTLIST_H_INCLUDED */
