#ifndef GTK_LICQ_BUTTON_H
#define GTK_LICQ_BUTTON_H 1
#include "gtk-gui.h"

#define GNOME_STOCK_BUTTON_PADDING 2

#define GTK_LICQ_BUTTON_SEND    0
#define GTK_LICQ_BUTTON_DETAILS 1
#define GTK_LICQ_BUTTON_OK      2
#define GTK_LICQ_BUTTON_CANCEL  3
#define GTK_LICQ_BUTTON_YES     4
#define GTK_LICQ_BUTTON_NO      5
#define GTK_LICQ_BUTTON_DONE    6
#define GTK_LICQ_BUTTON_SEARCH  7
#define GTK_LICQ_BUTTON_CLEAR   8
#define GTK_LICQ_BUTTON_APPLY   9
#define GTK_LICQ_BUTTON_UPDATE  10
#define GTK_LICQ_BUTTON_SET     11
#define GTK_LICQ_BUTTON_SAVE    12
#define GTK_LICQ_BUTTON_BROWSE  13
#define GTK_LICQ_BUTTON_CLOSE   14
#define GTK_LICQ_BUTTON_NEXT    15
#define GTK_LICQ_BUTTON_PREV    16
#define GTK_LICQ_BUTTON_FINISH  17
#define GTK_LICQ_BUTTON_REFUSE  18
#define GTK_LICQ_BUTTON_ACCEPT  19
#define GTK_LICQ_BUTTON_ENABLE  20
#define GTK_LICQ_BUTTON_DISABLE 21
#define GTK_LICQ_BUTTON_LOAD    22
#define GTK_LICQ_BUTTON_UNLOAD  23
#define GTK_LICQ_BUTTON_REFRESH 24
#define GTK_LICQ_BUTTON_ADD     25
#define GTK_LICQ_BUTTON_REMOVE  26
#define GTK_LICQ_BUTTON_SHIFTDOWN   27
#define GTK_LICQ_BUTTON_SHIFTUP     28
#define GTK_LICQ_BUTTON_ADDUSER     29
#define GTK_LICQ_BUTTON_REPLY       30
#define GTK_LICQ_BUTTON_QUOTEREPLY  31
#define GTK_LICQ_BUTTON_HOMEPAGE    32
#define GTK_LICQ_BUTTON_FORWARD     33
#define GTK_LICQ_BUTTON_RETRY       34

#define GTK_LICQ_BUTTON_ADDL    ( GTK_LICQ_BUTTON_ADD | 0x80 )
#define GTK_LICQ_BUTTON_REMOVEL    ( GTK_LICQ_BUTTON_REMOVE | 0x80 )
#define GTK_LICQ_BUTTON_SHIFTUPL    ( GTK_LICQ_BUTTON_SHIFTUP | 0x80 )
#define GTK_LICQ_BUTTON_SHIFTDOWNL    ( GTK_LICQ_BUTTON_SHIFTDOWN | 0x80 )
#define GTK_LICQ_BUTTON_SEARCHL    ( GTK_LICQ_BUTTON_SEARCH | 0x80 )
#define GTK_LICQ_BUTTON_CLEARL    ( GTK_LICQ_BUTTON_CLEAR | 0x80 )
#define GTK_LICQ_BUTTON_CANCELL    ( GTK_LICQ_BUTTON_CANCEL | 0x80 )

typedef int button_type;

GtkWidget *
gtk_licq_button                        (char        *label);

GtkWidget *
gtk_licq_button                        (button_type type);

void 
gtk_licq_button_set                    (GtkButton   *button, 
                                        char        *label);

void 
gtk_licq_button_set                    (GtkButton   *button, 
                                        button_type type);
#endif
