#ifndef INIT_H_INCLUDED
#define INIT_H_INCLUDED
#include "gtk-gui.h"
    /*  STUPID, will fix when i get to write into the licq cvs */
#define MAX_CONFIG_STRLEN 256
#include "gtk_licq_screensaver.h"
/* DND stuff */
enum {
    TARGET_STRING,
    TARGET_ROOTWIN,
    TARGET_URL
};

    /* If this is chnaged, dont forget to change the gtk_drag_dest_set too */
    /* Do not change first entry without updating event_window/contactlist 
       droppings */ 
static GtkTargetEntry target_table[] = {
    { "STRING",     0, TARGET_STRING },
    { "text/plain", 0, TARGET_STRING },
    { "text/uri-list", 0, TARGET_URL },
};

/* end DND stuff */

typedef struct {
        gint        x,y,width,height;
} windowposdata_t;
#define GETWINDOWPOSDATA(a,b) \
            (b).x=(a)->allocation.x; \
            (b).y=(a)->allocation.y; \
            (b).width=(a)->allocation.width; \
            (b).height=(a)->allocation.height;
#define SETWINDOWPOSDATA(a,b)  \
        gtk_window_set_default_size(GTK_WINDOW(a), (b).width, (b).height); 
/*#define SETWINDOWPOSDATA(a,b) gtk_widget_set_uposition(GTK_WIDGET(a), \
        (b).x,(b).y); \
        gtk_widget_set_default_size(GTK_WIDGET(a), (b).width, (b).height);*/
#define HASWINDOWPOSDATA(a) ((a).x||(a).y||(a).width||(a).height)
#define WINDOWPOSDATA(a) ((windowposdata_t)(a))

typedef struct {
        /*  Ignored for #0 */
    bool                active;
    gchar               title[MAX_CONFIG_STRLEN];
    gchar               format[MAX_CONFIG_STRLEN];
    gushort             width;
    GtkJustification    align;
} columns_t;

typedef struct {
    double              r,g,b;
} colordef_t;

typedef struct {
    unsigned long       uin;
    gint                x,y;
} floatiedata_t;
#define FLOATIEDATA(a) ((floatiedata_t*)(a))

typedef struct {
        /*  Status */
    gushort             autologon;
    bool                invisible;
    bool                showofflineusers;
    gushort             autoaway;
    gushort             autona;
    gushort             autooffline;
    bool                autoback;
    bool                showstatustimer;
        /*  Icons */
    gchar               iconset[MAX_CONFIG_STRLEN];
    gchar               usericondir[MAX_CONFIG_STRLEN];
        /*  Contactlist */
    columns_t           columns[4];
    bool                showcoltitles;
    bool                autopopupmessages,onlyautopopupwhenonline;
    bool                showgroupmenu;
    bool                showactiveuser;
    bool                singleclick;
    bool                blinkicons;
    gushort             sortlist[3];
        /*  Fonts */
    gchar               editorfont[MAX_CONFIG_STRLEN];
    gchar               contactfont[MAX_CONFIG_STRLEN];
    gulong              historylines;
    gulong              defaultheight,defaultwidth;
    gshort              default_x,default_y;
        /*  Colors */
    colordef_t          color_online,color_offline,color_other,
                        color_new,color_sent,color_rcvd;
    bool                ignoremsgcolors;
        /*  Misc */
    gulong              quotewidth;
    gushort             quicksearchcol;
    bool                autoraise;
    bool                autosendthroughserver;
    bool                wm_placement;
#ifdef USE_GNOME
    bool                use_gnomeurlviewer;
#endif
        /* OnEvent */
    bool                use_onevents;
    bool                beep_onevent;
        /* Chat */
    bool                audio_on;
    bool                show_font_toolbar;
    bool                show_style_toolbar;
    bool                use_own_font;
    bool                use_own_color;
    gushort             chat_mode;
    gchar               chat_font[XLFD_MAX_FIELD_LEN];
    gushort             chat_font_size;
    gshort              chat_fg_color;
    gshort              chat_bg_color;
    gushort             toolbar_style;

        /* File transfer */
    gchar               file_dir[MAX_CONFIG_STRLEN];
    bool                auto_close_file_win;
#ifdef USE_PANEL
        /* Initially launch panel */
    bool                launchpanel;
    bool                starthidden;
#endif
#ifdef USE_PSPELL
    char                spell_errorfont[MAX_CONFIG_STRLEN];
    char                defaut_dict[MAX_CONFIG_STRLEN];
    gushort             spelling_mode;
#endif
        /* Security */
    bool                auto_autosecure;
    
        /*  Used in runtime, never saved */
    windowposdata_t     pos_view_event_window,
                        pos_send_event_window,
                        pos_history_dialog,
                        pos_user_info_dialog,
                        pos_search_dialog,
                        pos_options_window,
                        pos_authorize_user_dialog,
                        pos_plugin_dialog,
                        pos_groups_dialog,
                        pos_autoresponse_dialog,
                        pos_refuse_dialog,
                        pos_event_autoresponse_dialog,
                        pos_network_dialog,
                        pos_randomchat_dialog,
                        pos_utilities_dialog,
                        pos_run_internal_dialog,
                        pos_multichat_window;
} configuration_t;

int
load_pixmaps();

int
load_colors();

int
setup_widgets();

void
gtk_plugin_terminate();

void 
signal_exit                            (int         sig);

int 
setup_unix_signals();

int
load_configuration();

int
save_configuration();

void
apply_options                          (int         reload_pixmaps);

int
init_main_contactlist();

void
init_eventwindows_contactlists();

GtkWidget *
create_contactlist                     (GtkWidget   *scrolledwindow,
                                        gboolean    ismainlist);

void
autoconnect();

GtkWidget*
create_status_menu                     (GtkSignalFunc
                                                    msgfunc,
                                        GtkSignalFunc 
                                                    nomsgfunc,
                                        gboolean    createinvisible,
                                        gboolean    addaccell,
                                        gboolean    addonandoffline);

GtkWidget *
create_send_menu                       (GtkWidget   *user_popup,
                                        ICQUser     *user);

GtkWidget *
create_utilities_menu                  (GtkWidget   *parent_menu);

void
rebuild_initial_floaties();

#endif /* INIT_H_INCLUDED */
